.\" Copyright (c) 1990, 1993, 1994
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)tftp.1	8.2 (Berkeley) 4/18/94
.\"
.Dd April 18, 1994
.Dt TFTP 1
.Os BSD 4.3
.Sh NAME
.Nm tftp
.Nd trivial file transfer program
.Sh SYNOPSIS
.Nm
.Op Ar host
.Sh DESCRIPTION
.Nm Tftp
is the user interface to the Internet
.Tn TFTP
(Trivial File Transfer Protocol),
which allows users to transfer files to and from a remote machine.
The remote
.Ar host
may be specified on the command line, in which case
.Nm
uses
.Ar host
as the default host for future transfers (see the
.Cm connect
command below).
.Sh COMMANDS
Once
.Nm
is running, it issues the prompt
.Nm tftp>
and recognizes the following commands:
.Pp
.Bl -tag -width verbose -compact
.It Cm \&? Ar command-name ...
Print help information.
.Pp
.It Cm ascii
Shorthand for "mode ascii"
.Pp
.It Cm binary
Shorthand for "mode binary"
.Pp
.It Cm connect Ar host-name Op Ar port
Set the
.Ar host
(and optionally
.Ar port )
for transfers.
Note that the
.Tn TFTP
protocol, unlike the
.Tn FTP
protocol,
does not maintain connections between transfers; thus, the
.Cm connect
command does not actually create a connection,
but merely remembers what host is to be used for transfers.
You do not have to use the 
.Cm connect
command; the remote host can be specified as part of the
.Cm get
or
.Cm put
commands.
.Pp
.It Cm get Ar filename
.It Cm get Ar remotename localname
.It Cm get Ar file1 file2 ...  fileN
Get a file or set of files from the specified
.Ar sources .
.Ar Source
can be in one of two forms:
a filename on the remote host, if the host has already been specified,
or a string of the form
.Ar hosts:filename
to specify both a host and filename at the same time.
If the latter form is used,
the last hostname specified becomes the default for future transfers.
.Pp
.It Cm mode Ar transfer-mode
Set the mode for transfers; 
.Ar transfer-mode
may be one of
.Em ascii
or
.Em binary .
The default is
.Em ascii .
.Pp
.It Cm put Ar file
.It Cm put Ar localfile remotefile
.It Cm put Ar file1 file2 ... fileN remote-directory
Put a file or set of files to the specified
remote file or directory.
The destination
can be in one of two forms:
a filename on the remote host, if the host has already been specified,
or a string of the form
.Ar hosts:filename
to specify both a host and filename at the same time.
If the latter form is used,
the hostname specified becomes the default for future transfers.
If the remote-directory form is used, the remote host is
assumed to be a
.Tn UNIX
machine.
.Pp
.It Cm quit
Exit
.Nm tftp .
An end of file also exits.
.Pp
.It Cm rexmt Ar retransmission-timeout
Set the per-packet retransmission timeout, in seconds.
.Pp
.It Cm status
Show current status.
.Pp
.It Cm timeout Ar total-transmission-timeout
Set the total transmission timeout, in seconds.
.Pp
.It Cm trace
Toggle packet tracing.
.Pp
.It Cm verbose
Toggle verbose mode.
.El
.Sh BUGS
.Pp
Because there is no user-login or validation within
the
.Tn TFTP
protocol, the remote site will probably have some
sort of file-access restrictions in place.  The
exact methods are specific to each site and therefore
difficult to document here.
.Sh HISTORY
The
.Nm
command appeared in
.Bx 4.3 .
